;program configuration

;EMC	.equ	$00 ; this is for memory crash. 
		    ; if set to 1,cancel changing bank.

;version info

;version
;	db	"  made with pmck 0.0.8  "
;
;-------------------------------------------------------------------------------
;macros and misc sub routines
;-------------------------------------------------------------------------------
;indirect_lda
;statement
;	indirect_lda	hoge_add_low	;hoge_add_low is not zero page address
;is same as:
;	lda	[hoge_add_low,x]
indirect_lda	.macro
	lda	\1,x		;hoge_add_low
	sta	<zero_add_low
	lda	\1+1,x		;hoge_add_high
	sta	<zero_add_high
	stx	<x_escape
	ldx	#$00
	lda	[zero_add_low,x]
	ldx	<x_escape
	.endm
;--------------------------------------	
reg400x:	; X = ݂ch<<1 , Y = X<<1
	lda	channel_sel
	asl	a
	tax
	asl	a
	tay
	rts

;-------------------------------------------------------------------------------
;initialize routine
;-------------------------------------------------------------------------------
INITIAL_WAIT_FRM = $00 ;ŏɂ̃t[EFCg
;[`
sound_init:

	lda	#$00
	ldx	#$00
.memclear
	sta	$0000,x
	sta	$0200,x
	sta	$0300,x
	sta	$0400,x
	sta	$0500,x
	sta	$0600,x
	sta	$0700,x
	inx
	bne	.memclear

	lda	#INITIAL_WAIT_FRM
	sta	initial_wait

	lda	#$0f		;
	sta	$4015		;`lgptO
	lda	#$08		
	sta	$4001		;`go2aȉ΍
	sta	$4005

	.if	SOUND_GENERATOR & __FME7
	jsr	fme7_sound_init
	.endif

	.if	SOUND_GENERATOR & __MMC5
	jsr	mmc5_sound_init
	.endif

	.if	SOUND_GENERATOR & __FDS
	jsr	fds_sound_init
	.endif
	
	.if	SOUND_GENERATOR & __N106
	jsr	n106_sound_init
	.endif

	.if	SOUND_GENERATOR & __VRC6
	jsr	vrc6_sound_init
	.endif

	lda	#$00
	sta	channel_sel
sound_channel_set:
	lda	channel_sel
	cmp	#PTR_TRACK_END		;IH
	beq	sound_init_end
	lda	channel_sel

	tay
	asl	a
	tax
	lda	#$00
;	sta	lfo_st_counter_1,x
	sta	effect_flag,x
	lda	#$01
	sta	sound_counter,x

	if (!EMC)
	lda	sound_data_bank,y
	sta	sound_bank,x
	endif
	
	lda	sound_data_table,x
	sta	<sound_add_low,x	;f[^Jnʒu
	inx
	lda	sound_data_table,x
	sta	<sound_add_low,x	;f[^Jnʒu

	inc	channel_sel
	jmp	sound_channel_set
sound_init_end:
	rts

;-------------------------------------------------------------------------------
;main routine
;-------------------------------------------------------------------------------
sound_driver_start:

	lda	initial_wait
	beq	.gogo
	dec	initial_wait
	rts
.gogo

	lda	#$00
	sta	channel_sel

internal_return:
	jsr	sound_internal
	inc	channel_sel		;̃`lݒ肵
	lda	channel_sel
	cmp	#$04
	bne	internal_return		;߂

;	.if	DPCMON
sound_dpcm_part:
	jsr	sound_dpcm
;	.endif
	inc	channel_sel		;̃`lݒ肵

	.if	SOUND_GENERATOR & __FDS
	jsr	sound_fds		;FDSsĂ
	inc	channel_sel		;̃`lݒ肵
	.endif

	.if	SOUND_GENERATOR & __VRC7
vrc7_return:
	jsr	sound_vrc7		;vrc7sĂ
	inc	channel_sel		;̃`lݒ肵
	lda	channel_sel
	sec
	sbc	#PTRVRC7
	cmp	#$06			;vrc7͏I肩H
	bne	vrc7_return		;܂Ȃ߂
	.endif

	.if	SOUND_GENERATOR & __VRC6
vrc6_return:
	jsr	sound_vrc6		;vrc6sĂ
	inc	channel_sel		;̃`lݒ肵
	lda	channel_sel
	sec
	sbc	#PTRVRC6
	cmp	#$03			;vrc6͏I肩H
	bne	vrc6_return		;܂Ȃ߂
	.endif

	.if	SOUND_GENERATOR & __N106
.rept:
	jsr	sound_n106		;n106sĂ
	inc	channel_sel		;̃`lݒ肵
	lda	channel_sel
	sec
	sbc	#PTRN106
	cmp	n106_channel		;n106͏I肩H
	bne	.rept			;܂Ȃ߂
	.endif

	.if	SOUND_GENERATOR & __FME7
fme7_return:
	jsr	sound_fme7		;fme7sĂ
	inc	channel_sel		;̃`lݒ肵
	lda	channel_sel
	sec
	sbc	#PTRFME7
	cmp	#$03			;fme7͏I肩H
	bne	fme7_return		;܂Ȃ߂
	.endif

	.if	SOUND_GENERATOR & __MMC5
mmc5_return:
	jsr	sound_mmc5		;mmc5sĂ
	inc	channel_sel		;̃`lݒ肵
	lda	channel_sel
	sec
	sbc	#PTRMMC5
	cmp	#$02			;mmc5͏I肩H
	bne	mmc5_return		;܂Ȃ߂
	.endif

	rts

;------------------------------------------------------------------------------
;command read sub routines
;------------------------------------------------------------------------------
sound_data_address:
	inc	<sound_add_low,x	;f[^AhX{P
	bne	return2			;ʂオ
	inc	<sound_add_high,x	;f[^AhXS̈ʁij{P
return2:
	rts
;-------------------------------------------------------------------------------
change_bank:
;oNReg.Aɕς܂`
;ύXoNAhX̓oNRg[ɂ
;݂NSF̂݁B
	if (!EMC)
;oN؂ւłcondition: A <= BANK_MAX_IN_4KB
;i.e. A < BANK_MAX_IN_4KB + 1
;i.e. A - (BANK_MAX_IN_4KB+1) < 0
;i.e. NOT ( A - (BANK_MAX_IN_4KB+1) >= 0 )
;skipcondition: A - (BANK_MAX_IN_4KB+1) >= 0
	cmp	#BANK_MAX_IN_4KB+1
	bcs	.avoidbankswitch
	sta	$5ffa ; A000h-AFFFh
	clc
	adc	#$01
	cmp	#BANK_MAX_IN_4KB+1
	bcs	.avoidbankswitch
	sta	$5ffb ; B000h-BFFFh
.avoidbankswitch
	endif
	rts

;-------------------------------------------------------------------------------
loop_sub:
	jsr	sound_data_address
	lda	channel_loop,x
	bne	loop_dec

	lda	[sound_add_low,x]
	sta	channel_loop,x
	jmp	loop_start
loop_dec:
	dec	channel_loop,x
	lda	#$01
	cmp	channel_loop,x
	beq	loop_end
loop_start:
	jsr	sound_data_address
	lda	[sound_add_low,x]
	pha
	jsr	sound_data_address
	lda	[sound_add_low,x]
	sta	<sound_add_high,x
	pla
	sta	<sound_add_low,x	;[vAhX
	rts
loop_end:
	dec	channel_loop,x
	jsr	sound_data_address	;f[^AhXi߂x3
	jsr	sound_data_address
	jsr	sound_data_address
	rts				;܂
;-------------------------------------------------------------------------------
loop_sub2:
	lda	channel_loop,x
	bne	loop_sbc2
loop_through:
	jsr	sound_data_address
	jsr	sound_data_address
	jsr	sound_data_address
	rts
loop_sbc2
	;and	#%00000001
	cmp	#$02
	bne	loop_through		;[łȂ΃X[
	dec	channel_loop,x
	dec	channel_loop,x
	jsr	sound_data_address	;[Ȃ烋[vAhX
	lda	[sound_add_low,x]
	pha
	jsr	sound_data_address	;[Ȃ烋[vAhX
	lda	[sound_add_low,x]
	sta	<sound_add_high,x
	pla
	sta	<sound_add_low,x	;[vJnʒu High
	rts

;-------------------------------------------------------------------------------
;oNZbg
data_bank_addr:
	jsr	sound_data_address
	
	if (!EMC)
	lda	[sound_add_low,x]
	sta	sound_bank,x
	endif

	jsr	sound_data_address
	lda	[sound_add_low,x]
	pha
	jsr	sound_data_address
	lda	[sound_add_low,x]
	sta	<sound_add_high,x
	pla
	sta	<sound_add_low,x	;VAhX

	rts
;-------------------------------------------------------------------------------
data_end_sub:
	ldy	channel_sel
	
	if (!EMC)
	lda	loop_point_bank,y
	sta	sound_bank,x
	endif
	
	lda	loop_point_table,x
	sta	<sound_add_low,x	;[vJnʒu Low
	inx
	lda	loop_point_table,x
	sta	<sound_add_low,x	;[vJnʒu High
	rts
;-------------------------------------------------------------------------------
volume_sub:
	lda	effect_flag,x
	ora	#%00000001
	sta	effect_flag,x		;\tgGxLw

;	lda	#$00
;	sta	register_low,x		;ʏ{[[

	lda	temporary
	sta	softenve_sel,x
	asl	a
	tay
	lda	softenve_table,y	;\tgGxf[^AhXݒ
	sta	soft_add_low,x
	iny
	lda	softenve_table,y
	sta	soft_add_high,x
	jsr	sound_data_address
	rts
;-------------------------------------------------------------------------------
lfo_set_sub:
	jsr	sound_data_address
	lda	[sound_add_low,x]
	cmp	#$ff
	bne	lfo_data_set

	jsr	reg400x
	lda	effect_flag,x
	and	#%10001111		;LFO
	sta	effect_flag,x
	jsr	sound_data_address
	rts
lfo_data_set:
	asl	a
	asl	a
	sta	lfo_data873,x

	tay
	lda	channel_sel
	asl	a
	tax
	lda	lfo_data,y
	sta	lfo_count,x		;fBCZbg
	sta	lfo_start_count,x
	iny
	lda	lfo_data,y
	sta	lfo_revers,x		;Xs[hZbg
	sta	lfo_revers_count,x
	iny
	lda	lfo_data,y
	sta	lfo_depth,x		;fvXZbg
	iny
	lda	lfo_data,y
	sta	lfo_harf_time,x
	sta	lfo_harf_count,x		;1/2JE^Zbg

	jsr	warizan_start

	lda	channel_sel		;Ȃ̏Ă邩Ƃ
	sec				;Ɗg+-tł
	sbc	#$05
	bcc	urararara2


	lda	effect_flag,x
	ora	#%00110000
	sta	effect_flag,x
	jmp	ittoke2
urararara2:
	lda	effect_flag,x
	and	#%11011111		;g`|
	ora	#%00010000		;LFOLtOZbg
	sta	effect_flag,x
ittoke2:
	jsr	sound_data_address
	rts
;-------------------------------------------------------------------------------
detune_sub:
	jsr	sound_data_address
	lda	[sound_add_low,x]
	cmp	#$ff
	bne	detune_data_set

	jsr	reg400x
	lda	effect_flag,x
	and	#%01111111		;detune
	sta	effect_flag,x
	jsr	sound_data_address
	rts
detune_data_set:
	pha
	jsr	reg400x
	pla
	tay
	sta	detune_dat,x
	lda	effect_flag,x
	ora	#%10000000		;detuneL
	sta	effect_flag,x
	jsr	sound_data_address
	rts
;-------------------------------------------------------------------------------
pitch_set_sub:
	jsr	sound_data_address
	lda	[sound_add_low,x]
	cmp	#$ff
	bne	pitch_enverope_part
	lda	effect_flag,x
	and	#%11111101
	sta	effect_flag,x
	jsr	sound_data_address
	rts

pitch_enverope_part:
	sta	pitch_sel,x
	asl	a
	tay
	lda	pitchenve_table,y
	sta	pitch_add_low,x
	iny
	lda	pitchenve_table,y
	sta	pitch_add_high,x
	lda	effect_flag,x
	ora	#%00000010
	sta	effect_flag,x
	jsr	sound_data_address
	rts
;-------------------------------------------------------------------------------
arpeggio_set_sub:
	jsr	sound_data_address
	lda	[sound_add_low,x]
	cmp	#$ff
	bne	arpeggio_part

	lda	effect_flag,x
	and	#%11110111
	sta	effect_flag,x
	jsr	sound_data_address
	rts

arpeggio_part:
	sta	arpeggio_sel,x
	asl	a
	tay
	lda	arpeggio_table,y
	sta	arpe_add_low,x
	iny
	lda	arpeggio_table,y
	sta	arpe_add_high,x

	lda	effect_flag,x
	ora	#%00001000
	sta	effect_flag,x
	jsr	sound_data_address
	rts
;-------------------------------------------------------------------------------
direct_freq_sub:
	jsr	sound_data_address
	lda	[sound_add_low,x]
	sta	sound_freq_low,x		;Low
	jsr	sound_data_address
	lda	[sound_add_low,x]
	sta	sound_freq_high,x		;High
	jsr	sound_data_address
	lda	[sound_add_low,x]
	sta	sound_counter,x			;Counter
	jsr	sound_data_address
	jsr	effect_init
	rts
;-------------------------------------------------------------------------------
y_sub:
	jsr	sound_data_address
	lda	[sound_add_low,x]
	sta	<reg_add_low
	jsr	sound_data_address
	lda	[sound_add_low,x]
	sta	<reg_add_high
	jsr	sound_data_address
	lda	[sound_add_low,x]
	ldx	#$00
	sta	[reg_add_low,x]
	jsr	reg400x
	jsr	sound_data_address
	rts
;-------------------------------------------------------------------------------
wait_sub:
	jsr	sound_data_address
	lda	[sound_add_low,x]
	sta	sound_counter,x
	jsr	sound_data_address

	rts
;-------------------------------------------------------------------------------


;-------------------------------------------------------------------------------
;effect sub routines
;-------------------------------------------------------------------------------
detune_write_sub:
	lda	effect_flag,x
	and	#%10000000
	bne	detune_part
	rts

detune_part:
	lda	detune_dat,x
	and	#%10000000
	bne	detune_minus

detune_plus:
	lda	detune_dat,x
	clc
	adc	sound_freq_low,x
	sta	sound_freq_low,x
	bcs	mid_plus
	rts
mid_plus:
	inc	sound_freq_high,x
	bne	n106_high_through
	inc	sound_freq_n106,x
n106_high_through:
	rts

detune_minus:
	lda	detune_dat,x
	and	#%01111111
	sta	detune_tmp
	lda	sound_freq_low,x
	sec
	sbc	detune_tmp
	sta	sound_freq_low,x
	bcc	mid_minus
	rts
mid_minus:
	lda	sound_freq_high,x
	beq	.borrow
.no_borrow
	dec	sound_freq_high,x
	rts
.borrow
	dec	sound_freq_high,x
	dec	sound_freq_n106,x
	rts
;----------------------------------------------
sound_software_enverope:
	jsr	volume_enve_sub
	sta	register_low,x
	ora	register_high,x		;Ff[^i4bitjƉ4bitőZ
	sta	$4000,y			;݁`
	jsr	enverope_address	;AhX₵
	rts				;܂

volume_enve_sub:
	jsr	reg400x

	indirect_lda	soft_add_low		;Gx[vf[^ǂݍ
	cmp	#$ff			;Ōォǁ[
	beq	return3			;ŌȂ烋[v
	rts

return3:
	lda	softenve_sel,x
	asl	a
	tay
	lda	softenve_lp_table,y
	sta	soft_add_low,x
	iny
	lda	softenve_lp_table,y
	sta	soft_add_high,x
	jmp	volume_enve_sub
;-------------------------------------------------------------------------------
enverope_address:
	inc	soft_add_low,x
	bne	return5
	inc	soft_add_high,x
return5:
	rts
;-------------------------------------------------------------------------------
sound_duty_enverope:
	jsr	reg400x

	lda	channel_sel
	cmp	#$02
	beq	return21		;OpgȂ΂`

	indirect_lda	duty_add_low		;Gx[vf[^ǂݍ
	cmp	#$ff			;Ōォǁ[
	beq	return22		;ŌȂ炻̂܂܂܂
	asl	a
	asl	a
	asl	a
	asl	a
	asl	a
	asl	a
	ora	#%00110000		;hardware envelope & ... disable
	sta	register_high,x
	ora	register_low,x		;Ff[^i4bitjƉ4bitőZ
	sta	$4000,y			;݁`
	jsr	duty_enverope_address	;AhX₵
return21:
	rts				;܂

return22:
	lda	duty_sel,x
	asl	a
	tay
	lda	dutyenve_lp_table,y
	sta	duty_add_low,x
	iny
	lda	dutyenve_lp_table,y
	sta	duty_add_high,x
	jmp	sound_duty_enverope

;-------------------------------------------------------------------------------
duty_enverope_address:
	inc	duty_add_low,x
	bne	return23
	inc	duty_add_high,x
return23:
	rts
;--------------------------------------	
sound_lfo:
	lda	sound_freq_high,x
	sta	temporary

	jsr	lfo_sub

	lda	sound_freq_low,x
	sta	$4002,y			;@@ݒlWX^ɃZbg
	lda	sound_freq_high,x
	cmp	temporary
	beq	end4
	sta	$4003,y
end4:
	rts				;܂
;-------------------------------------------------------------------------------
lfo_sub:
	jsr	reg400x
	lda	lfo_start_count,x
	beq	lfo_start
	dec	lfo_start_count,x
	rts
lfo_start:

	lda	effect_flag,x
	and	#%01000000
	bne	hanbun

	lda	lfo_harf_count,x
	beq	lfo_start_2

	dec	lfo_harf_count,x
	bne	lfo_start_2

	lda	effect_flag,x
	ora	#%01000000
	sta	effect_flag,x
hanbun:
	jsr	lfo_set_2
	lsr	lfo_revers,x
	lsr	lfo_revers_count,x
	jsr	warizan

lfo_start_2:
	asl	lfo_revers,x
	lda	lfo_revers_count,x	;݂̒lǂݍ
	cmp	lfo_revers,x
	beq	lfo_revers_set		;K萔ɒBĂ甽]Zbg
	jmp	lfo_depth_set		;BĂȂ΃fvX

lfo_revers_set:
	lda	#$00			;
	sta	lfo_revers_count,x	;]JE^
	lda	effect_flag,x		;GtFNgǂݍ
	pha				;ꎞޔ
	and	#%00100000
	bne	lfo_revers_p

	pla
	ora	#%00100000
	sta	effect_flag,x
	jmp	lfo_depth_set
lfo_revers_p:
	pla
	and	#%11011111
	sta	effect_flag,x

lfo_depth_set:
	lsr	lfo_revers,x
	lda	lfo_depth_count,x	;ԓǂݍ
	cmp	lfo_adc_sbc_time,x	;݂̃JE^Ɣr
	beq	lfo_depth_work		;vĂ΃fvX
	jmp	lfo_count_plus		;܂ȂJE^vX

lfo_depth_work:
	lda	#$00			;
	sta	lfo_depth_count,x	;fvXJE^
	lda	effect_flag,x		;{|
	and	#%00100000
	bne	lfo_depth_plus

lfo_depth_minus:
	lda	sound_freq_low,x	;fvXǂݍ
	sec
	sbc	lfo_depth,x		;
	sta	sound_freq_low,x
	bcc	lfo_high_minus		;
	jmp	lfo_count_plus
lfo_high_minus:
	lda	sound_freq_high,x
	beq	.borrow			;1OɃ[炻̏̌ɂ؂蔭
.no_borrow
	dec	sound_freq_high,x
	jmp	lfo_count_plus
.borrow
	dec	sound_freq_high,x
	dec	sound_freq_n106,x
	jmp	lfo_count_plus

lfo_depth_plus:
	lda	sound_freq_low,x	;fvXǂݍ
	clc
	adc	lfo_depth,x		;
	sta	sound_freq_low,x
	bcs	lfo_high_plus		;
	jmp	lfo_count_plus
lfo_high_plus:
	inc	sound_freq_high,x	;
	bne	lfo_count_plus
	inc	sound_freq_n106,x

lfo_count_plus:
	inc	lfo_revers_count,x	;JE^ĂI
	inc	lfo_depth_count,x
	lda	effect_flag,x
	and	#%01000000
	beq	endend
	jsr	lfo_set_2
	jsr	warizan
endend:
	rts

;-------------------------------------------------------------------------------
lfo_set_2:
	lda	lfo_data873,x
	tay
	lda	channel_sel
	asl	a
	tax
	iny
	lda	lfo_data,y
	sta	lfo_revers,x		;Xs[hZbg
	sta	lfo_revers_count,x
	iny
	lda	lfo_data,y
	sta	lfo_depth,x		;fvXZbg
	rts
;-------
warizan_start:
	lda	#$00
	sta	kotae
	lda	lfo_revers,x
	cmp	lfo_depth,x
	beq	plus_one
	bmi	depth_wari
revers_wari:
	lda	lfo_depth,x
	sta	waru
	lda	lfo_revers,x
	jsr	warizan
	lda	kotae
	sta	lfo_adc_sbc_time,x
	sta	lfo_depth_count,x
	lda	#$01
	sta	lfo_depth,x
	rts
depth_wari:
	lda	lfo_revers,x
	sta	waru
	lda	lfo_depth,x
	jsr	warizan
	lda	kotae
	sta	lfo_depth,x
	lda	#$01
	sta	lfo_adc_sbc_time,x
	sta	lfo_depth_count,x
	rts
plus_one:
	lda	#$01
	sta	lfo_depth,x
	sta	lfo_adc_sbc_time,x
	sta	lfo_depth_count,x
	rts
warizan:
	inc	kotae
	sec
	sbc	waru
	beq	warizan_end
	bcc	warizan_end
	jmp	warizan
warizan_end:
	rts

;-------------------------------------------------------------------------------
sound_pitch_enverope:
	lda	sound_freq_high,x
	sta	temporary
	jsr	pitch_sub
pitch_write:
	lda	sound_freq_low,x
	sta	$4002,y
	lda	sound_freq_high,x
	cmp	temporary
	beq	end3
	sta	$4003,y
end3:
	jsr	pitch_enverope_address
	rts
;-------------------------------------------------------------------------------
pitch_sub:
	jsr	reg400x
	indirect_lda	pitch_add_low	
	cmp	#$ff
	beq	return62

	and	#%10000000
;	cmp	#%10000000
	bne	pitch_plus

	indirect_lda	pitch_add_low	
	clc
	adc	sound_freq_low,x
	sta	sound_freq_low,x	;low
	bcs	freq_high_plus_2
	rts
freq_high_plus_2:
	inc	sound_freq_high,x	;high{P
	bne	rreturn
	inc	sound_freq_n106,x
rreturn
	rts				;WX^݂GO!
pitch_plus:
	indirect_lda	pitch_add_low	
	and	#%01111111
	sta	pitch_tmp
	sec
	lda	sound_freq_low,x
	sbc	pitch_tmp
	sta	sound_freq_low,x
	bcc	freq_high_minus_2
	rts
freq_high_minus_2:
	lda	sound_freq_high,x
	beq	.borrow
.no_borrow
	dec	sound_freq_high,x
	rts
.borrow
	dec	sound_freq_high,x
	dec	sound_freq_n106,x
	rts
;-------------------------------------------------------------------------------
return62:
	indirect_lda	pitch_add_low	
	lda	pitch_sel,x
	asl	a
	tay
	lda	pitchenve_lp_table,y
	sta	pitch_add_low,x
	iny
	lda	pitchenve_lp_table,y
	sta	pitch_add_high,x
	jmp	pitch_sub
;-------------------------------------------------------------------------------
pitch_enverope_address:
	inc	pitch_add_low,x
	bne	return63
	inc	pitch_add_high,x
return63:
	rts
;-------------------------------------------------------------------------------
sound_high_speed_arpeggio:		;note enverope
;	lda	sound_freq_high,x
;	sta	temporary2
	jsr	note_enve_sub
	bcs	.end4			;0Ȃ̂ŏȂĂ悵
	jsr	frequency_set
;.note_freq_write:
	jsr	reg400x
	lda	sound_freq_low,x
	sta	$4002,y
	lda	sound_freq_high,x
;	cmp	temporary2		;ɊԈ,yĂ̒Ă݂ǂłς
;	cmp	$4003,y
;	beq	.end2
	sta	$4003,y
;.end2:
	jsr	arpeggio_address
	rts
.end4
;	jsr	frequency_set
	jsr	arpeggio_address
	rts
;-------------------------------------------------------------------------------
note_add_set:
	lda	arpeggio_sel,x
	asl	a
	tay
	lda	arpeggio_lp_table,y
	sta	arpe_add_low,x
	iny
	lda	arpeggio_lp_table,y
	sta	arpe_add_high,x
	jmp	note_enve_sub
;-------------------------------------------------------------------------------
arpeggio_address:
	inc	arpe_add_low,x
	bne	return83
	inc	arpe_add_high,x
return83:
	rts
;-------------------------------------------------------------------------------
;----------------
;Output 
;	C=0(ǂݍ񂾒l0Ȃ̂Ŕ)
;	C=1(ǂݍ񂾒l0Ȃ̂ŔȂĂ)
;
note_enve_sub:

	jsr	reg400x
	indirect_lda	arpe_add_low		;m[gGxf[^ǂݏo
	cmp	#$ff			;$ffiIjH
	beq	note_add_set
	cmp	#$00			;[H
	beq	.note_enve_zero_end	;[ȂCĂĂI
	cmp	#$80
	beq	.note_enve_zero_end	;[ȂCĂĂI
	jmp	.arpeggio_sign_check
.note_enve_zero_end
	sec				;͕sv
	rts
.arpeggio_sign_check
	and	#%10000000
;	cmp	#%10000000		;|H
	bne	arpeggio_minus		;|

arpeggio_plus:
	indirect_lda	arpe_add_low		;m[gGxf[^ǂݏo
	sta	arpeggio_tmp		;e|ɒui[v񐔁j
arpeggio_plus2:
	lda	sound_sel,x		;Kf[^ǂݏo
	and	#$0f			;4bito
	cmp	#$0b			;bȂ
	beq	oct_plus		;IN^[u{
	inc	sound_sel,x		;łȂΉK{P
	jmp	loop_1			;[vP
oct_plus:
	lda	sound_sel,x		;Kf[^ǂݏo
	and	#$f0			;4bito4bit[
	clc
	adc	#$10			;IN^[u{P
	sta	sound_sel,x		;Kf[^o
loop_1:
	dec	arpeggio_tmp		;[v񐔁|P
	lda	arpeggio_tmp		;œǂݏo
;	cmp	#$00			;[H
	beq	note_enve_end		;Ȃ烋[vI
	jmp	arpeggio_plus2		;łȂ΂܂

arpeggio_minus:
	indirect_lda	arpe_add_low	
	and	#%01111111
	sta	arpeggio_tmp
arpeggio_minus2:
	lda	sound_sel,x		;Kf[^ǂݏo
	and	#$0f			;4bito
;	cmp	#$00			;[H
	beq	oct_minus		;[Ȃ|
	dec	sound_sel,x		;łȂΉK|P
	jmp	loop_2			;[vQ
oct_minus:
	lda	sound_sel,x		;Kf[^ǂݏo
	clc
	adc	#$0b			;+b
	sec
	sbc	#$10			;-10
	sta	sound_sel,x		;Kf[^o
loop_2:
	dec	arpeggio_tmp		;[v񐔁|P
	lda	arpeggio_tmp		;œǂݏo
	cmp	#$00			;[H
	bne	arpeggio_minus2		;Ȃ烋[vI
note_enve_end:
	clc				;͕Kv
	rts				;
;-------------------------------------------------------------------------------
;oto_setŌĂ΂
effect_init:
;\tgEFAGx[vǂݍ݃AhX
	lda	softenve_sel,x
	asl	a
	tay
	lda	softenve_table,y
	sta	soft_add_low,x
	iny
	lda	softenve_table,y
	sta	soft_add_high,x

;sb`Gx[vǂݍ݃AhX
	lda	pitch_sel,x
	asl	a
	tay
	lda	pitchenve_table,y
	sta	pitch_add_low,x
	iny
	lda	pitchenve_table,y
	sta	pitch_add_high,x

;f[eBGx[vǂݍ݃AhX
	lda	duty_sel,x
	asl	a
	tay
	lda	dutyenve_table,y
	sta	duty_add_low,x
	iny
	lda	dutyenve_table,y
	sta	duty_add_high,x

;m[gGx[vǂݍ݃AhX
	lda	arpeggio_sel,x
	asl	a
	tay
	lda	arpeggio_table,y
	sta	arpe_add_low,x
	iny
	lda	arpeggio_table,y
	sta	arpe_add_high,x
;\tgEFALFO
	lda	lfo_count,x
	sta	lfo_start_count,x
	lda	lfo_adc_sbc_time,x
	sta	lfo_depth_count,x
	lda	lfo_harf_time,x
	sta	lfo_harf_count,x
	lda	lfo_revers,x
	sta	lfo_revers_count,x

	lda	channel_sel
	sec
	sbc	#$04
	bmi	urararara

	lda	effect_flag,x
	and	#%10111111
	ora	#%00100000
	sta	effect_flag,x
	jmp	ittoke
urararara:
	lda	effect_flag,x
	and	#%10011111
	sta	effect_flag,x
	
ittoke:
;xtONA&Key OntO
	lda	#%00000010
	sta	rest_flag,x
	rts


;-------------------------------------------------------------------------------
;internal 4 dpcm 1 fds 1 vrc7 6 vrc6 3 n106 8 fme7 3 mmc5 3(?)
;4+1+1+6+3+8+3+3=29ch
MAX_CH		=	$20		;32ch
;-------------------------------------------------------------------------------
;memory definition
;-------------------------------------------------------------------------------
;[y[W`
sound_add_low	=	$10		;command address
sound_add_high	=	$10+1		;

reg_add_low	=	$f9	;temp
reg_add_high	=	$fa
x_escape	=	$fb
zero_add_low	=	$fc
zero_add_high	=	$fd
fds_wave_address=	$fe
fds_wave_addhigh=	$ff
vrc7_wave_add	=	$fe
vrc7_wave_add_hi=	$ff
VRC6_DST_REG_LOW=	$fe
VRC6_DST_REG_HIGH=	$ff
n106_wave_add	=	$fe
n106_wave_add_hi=	$ff

;ȊOɕKvȃ
;	jsr	reg400x
;	Ă
;	lda	memory,x
;	̂1oCgɃf[^Ȃ

;_add_low_add_high͋ߐڂĂKv
soft_add_low	=	$0200+MAX_CH* 0  	;software envelope(@v) address
soft_add_high	=	$0200+MAX_CH* 0+1	;
pitch_add_low	=	$0200+MAX_CH* 2  	;pitch envelope (EP) address
pitch_add_high	=	$0200+MAX_CH* 2+1	;
duty_add_low	=	$0200+MAX_CH* 4  	;duty envelope (@@) address
duty_add_high	=	$0200+MAX_CH* 4+1	;
arpe_add_low	=	$0200+MAX_CH* 6  	;note envelope (EN) address
arpe_add_high	=	$0200+MAX_CH* 6+1	;
lfo_revers_count=	$0200+MAX_CH* 8  	;
lfo_depth_count	=	$0200+MAX_CH* 8+1	;
lfo_start_count	=	$0200+MAX_CH*10  	;
lfo_count	=	$0200+MAX_CH*10+1	;
lfo_adc_sbc_time=	$0200+MAX_CH*12  	;
lfo_depth	=	$0200+MAX_CH*12+1	;
lfo_revers	=	$0200+MAX_CH*14  	;
lfo_harf_time	=	$0200+MAX_CH*14+1	;gp
lfo_data873	=	$0200+MAX_CH*16  	;vibrato (MP) no
lfo_harf_count	=	$0200+MAX_CH*16+1	;?
detune_dat	=	$0200+MAX_CH*18  	;detune value
register_high	=	$0200+MAX_CH*18+1	;
register_low	=	$0200+MAX_CH*20  	;
duty_sel	=	$0200+MAX_CH*20+1	;duty envelope no
channel_loop	=	$0200+MAX_CH*22  	;|: :| loop counter
rest_flag	=	$0200+MAX_CH*22+1	;
softenve_sel	=	$0200+MAX_CH*24  	;software envelope(@v) no
pitch_sel	=	$0200+MAX_CH*24+1	;pitch envelope (EP) no
arpeggio_sel	=	$0200+MAX_CH*26  	;note envelope (EN) no
effect_flag	=	$0200+MAX_CH*26+1	;
sound_sel	=	$0200+MAX_CH*28  	;note no.
sound_counter	=	$0200+MAX_CH*28+1	;wait counter
sound_freq_low	=	$0200+MAX_CH*30  	;
sound_freq_high	=	$0200+MAX_CH*30+1	;
sound_freq_n106	=	$0200+MAX_CH*32  	;n106ȂchłgĂ
sound_bank	=	$0200+MAX_CH*32+1	;
extra_mem0	=	$0200+MAX_CH*34  	;chƂɗprႤ
extra_mem1	=	$0200+MAX_CH*34+1	;
extra_mem2	=	$0200+MAX_CH*36  	;

n106_volume	=	extra_mem0
n106_7c		=	extra_mem1

vrc7_key_stat	=	extra_mem0
vrc7_volume	=	extra_mem1

	.if	$0200+MAX_CH*38 > $0790
	.fail	"memory out of range"
	.endif
;̑
waru		=	$079c	;1byte
kotae		=	$079d	;1byte

detune_tmp	=	$07a1	;1byte
pitch_tmp	=	$07a3	;1byte
arpeggio_tmp	=	$07a5	;1byte
temporary	=	$07a7	;1byte
channel_sel	=	$07a9	;1byte
temporary2	=	$07ab

fds_hard_select	=	$07af
fds_volume	=	$07b1

n106_7f		=	$07b5

vrc7_temp	=	$07b8
n106_temp	=	$07b9
n106_temp_2	=	$07bb

fds_hard_count_1=	$07c0
fds_hard_count_2=	$07c1

initial_wait	=	$07c3

fme7_ch_sel	=	$07c5
fme7_ch_selx2	=	$07c6
fme7_data	=	$07c7
fme7_adr	=	$07c8


;effect_flag: DLLLadpv
;+------ detune flag
;l+----- software LFOXs[hσtOi\j
;ll+---- software LFOtO0=- 1=+
;lll+--- software LFO flag
;llll+---- note enverope flag
;lllll+--- duty enverope flag / FDS hardware effect flag
;llllll+-- pitch enverope flag
;lllllll+- software enverope flag
;llllllll
;DLLLadpv


;rest_flag
;xxxxxxor
;|||||||+- rest
;||||||+-- key on (if set, must do sound_data_write)
;